package com.huimv.devicedata.controller;

import com.alibaba.fastjson.JSONObject;
import com.huimv.devicedata.service.IDeviceDataService;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.Calendar;
import java.util.Date;

/**
 * @Project : huimv.shiwan
 * @Package : com.huimv.biosafety.uface.controller
 * @Description : TODO
 * @Version : 1.0
 * @Author : ZhuoNing
 * @Create : 2020-12-25
 **/
@RestController
@RequestMapping(value = "/deviceData",method = RequestMethod.POST)
public class DeviceDataController {
    public static Logger logger = LoggerFactory.getLogger(DeviceDataController.class);
    @Autowired
    private IDeviceDataService deviceDataService;

    @RequestMapping(value = "/deviceChange",method = {RequestMethod.POST,RequestMethod.GET})
    public String deviceUpAndDown(HttpServletRequest request, HttpServletResponse response){
        long startTime = Calendar.getInstance().getTimeInMillis();
        Date startDate = new Date(startTime);
        java.text.SimpleDateFormat f = new java.text.SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        logger.info("开始接收时间："+f.format(startDate));

        StringBuffer resultStr = new StringBuffer("");
        try{
            BufferedReader br = new BufferedReader(new InputStreamReader(request.getInputStream(),"utf-8"));
            StringBuffer sb = new StringBuffer("");
            String temp;
            while ((temp = br.readLine()) != null){
                sb.append(temp);
            }
            br.close();
            //真正接收到的数据
            String result = sb.toString();
            System.out.println("接收到数据result>>"+result);
//          result = "{'upPacketSN':-1,'upDataSN':-1,'topic':'v1/up/ad19','timestamp':1617172207604,'tenantId':'2000031842','serviceId':12,'protocol':'lwm2m','productId':'15039192','payload':{'VER':1,'TIME':15,'TEMP':201,'STC':94,'RSSI':18,'HUMI':564,'BAT':3600},'messageType':'dataReport','deviceType':'','deviceId':'488200bd80e14a97826c95834dee135e','assocAssetId':'','IMSI':'undefined','IMEI':'864333043632975'}";
            JSONObject deviceUpDataJson = JSONObject.parseObject(result);
            // 保存设备上传数据
            deviceDataService.saveDeviceChangedUpData(deviceUpDataJson);
        }catch (Exception e){
            e.printStackTrace();
        }
//        return resultStr;

        return "200";
    }
}
